;*****************************************************************************
;*
;*	Safedisc Analyser v3.4
;*	Copyright 2000  dec0de12
;*	use MASM (tab4)
;*
;*****************************************************************************

	.486p
	.model	flat, stdcall
	option	casemap :none

;-----------------------------------------------------------------------------

	UNICODE				= 0

	cWndWidth			= 500
	cWndHeigth			= 330

	cID_MainIcon		= 500
	cID_Timer			= 520
	cID_ButtonExit		= 530
	cID_ButtonLoad		= 531
	cID_StatExeName		= 600
	cID_StatIcdName		= 601
	cID_StatVersion		= 610
	cID_StatCRC			= 615
	cID_StatTEA			= 620
	cID_StatDll1		= 630
	cID_StatDll2		= 632
	cID_StatDll3		= 634
	cID_EditExeName		= 650
	cID_EditIcdName		= 651
	cID_EditVersion		= 660
	cID_EditRelease		= 661
	cID_EditCRC1		= 665
	cID_EditCRC2		= 666
	cID_EditTEA1		= 670
	cID_EditTEA2		= 671
	cID_EditTEA3		= 672
	cID_EditTEA4		= 673
	cID_EditDll1_1		= 680
	cID_EditDll1_2		= 681
	cID_EditDll2_1		= 682
	cID_EditDll2_2		= 683
	cID_EditDll3_1		= 684
	cID_EditDll3_2		= 685

;-----------------------------------------------------------------------------

	include	inc\standard\Macros.inc
	include	c:\MASM32\INCLUDE\windows.inc
	include	c:\MASM32\INCLUDE\user32.inc
	include	c:\MASM32\INCLUDE\kernel32.inc
	include	c:\MASM32\INCLUDE\comctl32.inc
	include	c:\MASM32\INCLUDE\comdlg32.inc
	include	c:\MASM32\INCLUDE\gdi32.inc
	includelib c:\MASM32\LIB\user32.lib
	includelib c:\MASM32\LIB\kernel32.lib
	includelib c:\MASM32\LIB\comctl32.lib
	includelib c:\MASM32\LIB\comdlg32.lib
	includelib c:\MASM32\LIB\gdi32.lib

	WndProc							PROTO :DWORD,:DWORD,:DWORD,:DWORD
	prGetWinMiddle					PROTO :DWORD,:DWORD
	prCreateStaticText				PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	prCreateButton					PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
;	prCreateCheckButton				PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
;	prCreateGroupBox				PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	prCreateEdit					PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	Thread_Load						PROTO
	CloseAll						PROTO


;-----------------------------------------------------------------------------

cFlag_ExeLoaded			= 1
cFlag_IcdLoaded			= 2
cFlag_VersionFound		= 4
cFlag_VersionKnown		= 8
cFlag_CRC_CalcFound		= 10h
cFlag_CRC_ReadFound		= 20h
cFlag_Raw_KeysFound		= 40h
cFlag_TEA_KeyFound		= 80h
cFlag_TEA_Key128		= 100h

cFlag_ErrOpenFile		= 1000000h
cFlag_ErrReadFile		= 2000000h
cFlag_ErrStructure		= 4000000h
cFlag_ErrAllocMem		= 8000000h
cFlag_HardErrors		= 0ff000000h

cFlag_SecImport			= 00000002h
cFlag_SecReloc			= 00000020h
cFlag_SecInCode			= 00010000h
cFlag_SecInData			= 00020000h
cFlag_SecCode			= 01000000h
cFlag_SecInitData		= 02000000h
cFlag_SecNoInitData		= 04000000h
cFlag_SecNoImage		= 08000000h
cFlag_SecNotNeeded		= 10000000h
cFlag_SecExeable		= 20000000h
cFlag_SecReadable		= 40000000h
cFlag_SecWriteable		= 80000000h


;-----------------------------------------------------------------------------
.data

	include	inc\Data\VersionList.inc


stWndClass			WNDCLASSEX < sizeof WNDCLASSEX, CS_HREDRAW or CS_VREDRAW, \	;or CS_BYTEALIGNWINDOW
						offset WndProc, 0, 0, 0, 0, 0, COLOR_APPWORKSPACE, \
						0, szWndClassName, 0 >

stOpenFile			OPENFILENAMEA< sizeof OPENFILENAMEA, 0, 0, \
						0, 0, 0, 0, offset szOFN_FileName, 200h, 0, \
						0, offset szInitDir, 0, OFN_FILEMUSTEXIST, 0, 0, 0, 0, 0, 0 >

stFont				LOGFONTA< 8, 0, 0, 0, FW_NORMAL, 0, 0, 0, DEFAULT_CHARSET, \
						OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, \
						DEFAULT_PITCH, "MS Sans Serif">

szWinTitle			db "Safedisc Analyser v3.4  (dec0de12)",0
szWndClassName		db "AnalyserWnd_Class",0
szClass_Static		db "STATIC",0
szClass_Button		db "BUTTON",0
szClass_Edit		db "EDIT",0

szButtonLoad		db "Load",0
szButtonExit		db "Exit",0

szProofString		db "BoG_ *90.0&!!  Yy>",0,0
szMaskVersion		db "v%.1u.%.2u.%.3u",0
szMaskRelease		db "R%.1u (%c%.1u)",0
szMaskHex			db "%.8x",0
szMaskInt			db "%u",0
szReport			db "please report about this version @"
					db 13,10,"http://www.insidetheweb.com/mbs.cgi/mb1010421",0
szMask_EXE			db "Safedisc Encrypted Files (*.exe)",0,"*.exe",0
					db "All Files (*.*)",0,"*.*",0,0
szMask_ICD			db "Safedisc Encrypted Files (*.icd)",0,"*.icd",0
					db "All Files (*.*)",0,"*.*",0,0
;szMask_Dll			db "Dynamic Link Library (*.dll)",0,"*.dll",0
;					db "All Files (*.*)",0,"*.*",0,0
szInitDir			db ".\",0
szErrOpenFile		db "Open File Error",0
szErrReadFile		db "Read File Error",0
szErrStructure		db "Bad EXE Header Structure!",0
szErrAllocMem		db "Memory Allocation Error!",0

szNoTxt				db "-",0
szStatExeName		db "EXE-Filename:",0
szStatIcdName		db "ICD-Filename:",0
szStatVersion		db "Version / Release:",0
szStatCRC			db "CRC (Calc/Proof):",0
szStatTEA			db "TEA Key:",0
szStatDll1			db "1.DLL Key:",0
szStatDll2			db "2.DLL Key:",0
szStatDll3			db "3.DLL Key:",0

;-----------------------------------------------------------------------------
.data?

hFont				dd ?
hWnd				dd ?
hButtonLoad			dd ?
hButtonExit			dd ?

hInstance			dd ?
Msg					MSG <?>
dwThreadID			dd ?
hThread				dd ?
dwThreadStatus		dd ?
dwTimerID			dd ?

hStatExeName		dd ?
hStatIcdName		dd ?
hStatVersion		dd ?
hStatCRC			dd ?
hStatTEA			dd ?
hStatDll1			dd ?
hStatDll2			dd ?
hStatDll3			dd ?

hEditExeName		dd ?
hEditIcdName		dd ?
hEditVersion		dd ?
hEditRelease		dd ?
hEditCrc1			dd ?
hEditCrc2			dd ?
hEditTea1			dd ?
hEditTea2			dd ?
hEditTea3			dd ?
hEditTea4			dd ?
hEditDll1_1			dd ?
hEditDll1_2			dd ?
hEditDll2_1			dd ?
hEditDll2_2			dd ?
hEditDll3_1			dd ?
hEditDll3_2			dd ?

bChangedExeName		db ?
bChangedIcdName		db ?
bChangedVersion		db ?
bChangedRelease		db ?
bChangedCrc			db ?
bChangedTea			db ?
bChangedDll			db ?

stcSectionParam		STRUC
	dwRVA			dd ?
	dwFOA			dd ?
	dwSize			dd ?
	dwFlags			dd ?
stcSectionParam		ENDS
tSectionParam		stcSectionParam	16 dup (<>)
dwSectionNum		dd ?

dwRelocTerminator	dd ?
tCRC_RelocBuffer	dd 400h dup (?)
dwLastReloc			dd ?
pRelocBuffer		dd ?
dwBlockRelocBase	dd ?
dwBlockRelocNum		dd ?

szTextBuffer		db 400h dup (?)
szOFN_FileName		db 200h dup (?)
szIcdName			db 200h dup (?)
szExeName			db 200h dup (?)

hEXE_File			dd ?
hICD_File			dd ?
hDllHandle			dd ?
pStSafeMem			dd ?

stcSafeMem			STRUC
	pMem			dd ?
	dwSize			dd ?
	dwBase			dd ?
	dwOffset		dd ?
stcSafeMem			ENDS

stExeFileMem		stcSafeMem <>
stFileMem			stcSafeMem <>
stMarkTabMem		stcSafeMem <>

dwVersion			dd ?
dwVersion1			dd ?
dwVersion2			dd ?
dwVersion3			dd ?
dwRelease1			dd ?
dwRelease2			dd ?
dwRelease3			dd ?

dwCrcCalc			dd ?
dwCrcRead			dd ?
dwRaw_Key			dd 4 dup (?)
dwTEA_Key			dd 4 dup (?)
dwTEA_KeyMask		dd ?
bAsciiKey			db 4 dup (?)

stcDllKey			STRUC
	dwKey			dd ?
	pOrgThunk		dd ?
	pName			dd ?
	pThunk			dd ?
stcDllKey			ENDS
stDllSize			= 4*4

stDlls				stcDllKey 7 dup (<>)
szDll1				db 40h dup (?)
szDll2				db 40h dup (?)
szDll3				db 40h dup (?)
dwDllKeyNum			dd ?
pKeyTabMem			dd ?
dwNumFoundKeys		dd ?
dwNumLeftAsciis		dd ?

dwPE_Offset			dd ?
dwPE_FirstSection	dd ?
dwImportSecParam	dd ?
dwImportSectionRVA	dd ?
dwImportSectionFOA	dd ?
dwImportSectionSize	dd ?
dwImportRVA			dd ?
dwImportFOA			dd ?					; 0 = No Imports
dwRelocRVA			dd ?
dwRelocFOA			dd ?

dwCodeStart			dd ?
dwCodeSize			dd ?
dwDataStart			dd ?
dwDataSize			dd ?
dwEntrypoint		dd ?

dwFreeVar			dd ?
dwFlags				dd ?

;-----------------------------------------------------------------------------
.code

Main:
	cld
	invoke	GetModuleHandle, 0
	mov		[hInstance], eax
	invoke	InitCommonControls

	;============
	; Create Font
	;============

	lea		eax, stFont
	invoke	CreateFontIndirectA, eax
	mov		[hFont], eax

	;==================================================
	; Fill WNDCLASSEX structure with required variables
	;==================================================

	m2m		stWndClass.hInstance, [hInstance]

	invoke	LoadIcon, [hInstance], cID_MainIcon
	mov		[stWndClass.hIcon], eax
	mov		[stWndClass.hIconSm], eax

	invoke	LoadCursor, 0, IDC_ARROW
	mov		[stWndClass.hCursor], eax

	invoke	RegisterClassEx, offset stWndClass

	;=======================
	; Centre & Create Window
	;=======================

	invoke	prGetWinMiddle, SM_CXSCREEN, cWndWidth
	push	eax
	invoke	prGetWinMiddle, SM_CYSCREEN, cWndHeigth	; top
	pop		edx										; left

	invoke	CreateWindowEx, WS_EX_LEFT or WS_EX_OVERLAPPEDWINDOW,
				offset szWndClassName, offset szWinTitle,
				WS_OVERLAPPEDWINDOW, edx, eax, cWndWidth,
				cWndHeigth, 0, 0, [hInstance], 0

	mov		[hWnd], eax

	invoke	ShowWindow, [hWnd], SW_SHOWNORMAL
	invoke	UpdateWindow, [hWnd]

	;===================================
	; Loop until PostQuitMessage is sent
	;===================================

MainLoop:
	invoke	GetMessage, offset Msg, 0, 0, 0
	test	eax, eax
	je		MainCiao

	invoke	TranslateMessage, offset Msg
	invoke	DispatchMessage, offset Msg
	jmp		MainLoop

MainCiao:
	invoke	ExitProcess, [Msg.wParam]


;-----------------------------------------------------------------------------

WndProc		PROC	arg_hWin	:DWORD, \
					arg_uMsg	:DWORD, \
					arg_wParam	:DWORD, \
					arg_lParam	:DWORD


	.if		[arg_uMsg] == WM_TIMER

		.if		[dwThreadStatus] == -1				; Thread finished ?
			inc		[dwThreadStatus]				; Thread waiting
			mov		eax, [hThread]
			.if		eax == 0
			.else
				invoke	CloseHandle, eax
			.endif
		.endif
		.if		[bChangedIcdName] == -1
			inc		[bChangedIcdName]
			invoke	SetWindowText, [hEditIcdName], ADDR szIcdName
		.endif
		.if		[bChangedExeName] == -1
			inc		[bChangedExeName]
			invoke	SetWindowText, [hEditExeName], ADDR szExeName
		.endif
		.if		[bChangedVersion] == -1
			inc		[bChangedVersion]
			lea		esi, szNoTxt
			test	[dwFlags], cFlag_VersionFound
			je		@@NoVersion
			lea		esi, szTextBuffer
		@@NoVersion:
			invoke	wsprintf, ADDR szTextBuffer, ADDR szMaskVersion, [dwVersion1], [dwVersion2], [dwVersion3]
			invoke	SetWindowText, [hEditVersion], esi
		.endif
		.if		[bChangedRelease] == -1
			inc		[bChangedRelease]
			lea		esi, szNoTxt
			test	[dwFlags], cFlag_VersionKnown
			je		@@NoRelease
			lea		esi, szTextBuffer
		@@NoRelease:
			invoke	wsprintf, ADDR szTextBuffer, ADDR szMaskRelease, [dwRelease1], [dwRelease2], [dwRelease3]
			invoke	SetWindowText, [hEditRelease], esi
		.endif
		.if		[bChangedCrc] == -1
			inc		[bChangedCrc]
			lea		esi, szNoTxt
			test	[dwFlags], cFlag_CRC_CalcFound
			je		@@NoCRC_Calc
			lea		esi, szTextBuffer
		@@NoCRC_Calc:
			invoke	wsprintf, ADDR szTextBuffer, ADDR szMaskHex, [dwCrcCalc]
			invoke	SetWindowText, [hEditCrc1], esi
			lea		esi, szNoTxt
			test	[dwFlags], cFlag_CRC_ReadFound
			je		@@NoCRC_Read
			lea		esi, szTextBuffer
		@@NoCRC_Read:
			invoke	wsprintf, ADDR szTextBuffer, ADDR szMaskHex, [dwCrcRead]
			invoke	SetWindowText, [hEditCrc2], esi
		.endif
		.if		[bChangedTea] == -1
			inc		[bChangedTea]
			lea		esi, szNoTxt
			test	[dwFlags], cFlag_TEA_KeyFound
			je		@@No32Key
			lea		esi, szTextBuffer
		@@No32Key:
			invoke	wsprintf, ADDR szTextBuffer, ADDR szMaskHex, [dwTEA_Key]
			invoke	SetWindowText, [hEditTea1], esi

			lea		esi, szNoTxt
			test	[dwFlags], cFlag_TEA_Key128
			je		@@No128Key
			lea		esi, szTextBuffer
		@@No128Key:
			invoke	wsprintf, ADDR szTextBuffer, ADDR szMaskHex, [dwTEA_Key][4]
			invoke	SetWindowText, [hEditTea2], esi
			invoke	wsprintf, ADDR szTextBuffer, ADDR szMaskHex, [dwTEA_Key][8]
			invoke	SetWindowText, [hEditTea3], esi
			invoke	wsprintf, ADDR szTextBuffer, ADDR szMaskHex, [dwTEA_Key][12]
			invoke	SetWindowText, [hEditTea4], esi
		.endif
		.if		[bChangedDll] == -1
			inc		[bChangedDll]
			lea		esi, szTextBuffer
			cmp		[dwDllKeyNum], 3
			jge		@@FoundThirdDll
			lea		esi, szNoTxt
			mov		eax, 2dh
			mov		dword ptr [szDll3], eax
		@@FoundThirdDll:
			invoke	wsprintf, ADDR szTextBuffer, ADDR szMaskHex, [stDlls.dwKey+2*stDllSize]
			invoke	SetWindowText, [hEditDll3_1], esi
			invoke	SetWindowText, [hEditDll3_2], ADDR szDll3
			lea		esi, szTextBuffer
			cmp		[dwDllKeyNum], 2
			jge		@@FoundSecondDll
			lea		esi, szNoTxt
			mov		eax, 2dh
			mov		dword ptr [szDll2], eax
		@@FoundSecondDll:
			invoke	wsprintf, ADDR szTextBuffer, ADDR szMaskHex, [stDlls.dwKey+stDllSize]
			invoke	SetWindowText, [hEditDll2_1], esi
			invoke	SetWindowText, [hEditDll2_2], ADDR szDll2
			lea		esi, szTextBuffer
			cmp		[dwDllKeyNum], 1
			jge		@@FoundFirstDll
			lea		esi, szNoTxt
			mov		eax, 2dh
			mov		dword ptr [szDll1], eax
		@@FoundFirstDll:
			invoke	wsprintf, ADDR szTextBuffer, ADDR szMaskHex, [stDlls.dwKey]
			invoke	SetWindowText, [hEditDll1_1], esi
			invoke	SetWindowText, [hEditDll1_2], ADDR szDll1
		.endif
		jmp		@@Ciao0

;-----------

	.elseif	[arg_uMsg] == WM_COMMAND

		.if		[arg_wParam] == cID_ButtonExit
			invoke	SendMessage, [arg_hWin], WM_SYSCOMMAND, SC_CLOSE, 0

		.elseif	[arg_wParam] == cID_ButtonLoad
			.if		[dwThreadStatus] == 0			; Thread inactive ?
				inc		[dwThreadStatus]			; Thread running
				invoke	CreateThread, 0, 0, ADDR Thread_Load, 0, 0, offset dwThreadID
				mov		[hThread], eax
				.if		eax == 0					; Error ?
					dec		[dwThreadStatus]
				.endif
			.endif

		.endif

;-----------

	.elseif		[arg_uMsg] == WM_CREATE

		invoke	prCreateButton, ADDR szButtonLoad, [arg_hWin], 10, 262, 100, 27, cID_ButtonLoad
		mov		[hButtonLoad], eax
		invoke	prCreateButton, ADDR szButtonExit, [arg_hWin], 380, 262, 100, 27, cID_ButtonExit
		mov		[hButtonExit], eax

		invoke	prCreateStaticText, ADDR szStatExeName, [arg_hWin], 10, 15, 100, 18, cID_StatExeName
		mov		[hStatExeName], eax
		invoke	prCreateStaticText, ADDR szStatIcdName, [arg_hWin], 10, 45, 100, 18, cID_StatIcdName
		mov		[hStatIcdName], eax
		invoke	prCreateStaticText, ADDR szStatVersion, [arg_hWin], 10, 75, 100, 18, cID_StatVersion
		mov		[hStatVersion], eax
		invoke	prCreateStaticText, ADDR szStatCRC, [arg_hWin], 10, 105, 100, 18, cID_StatCRC
		mov		[hStatCRC], eax
		invoke	prCreateStaticText, ADDR szStatTEA, [arg_hWin], 10, 135, 100, 18, cID_StatTEA
		mov		[hStatTEA], eax
		invoke	prCreateStaticText, ADDR szStatDll1, [arg_hWin], 10, 165, 100, 18, cID_StatDll1
		mov		[hStatDll1], eax
		invoke	prCreateStaticText, ADDR szStatDll2, [arg_hWin], 10, 195, 100, 18, cID_StatDll2
		mov		[hStatDll2], eax
		invoke	prCreateStaticText, ADDR szStatDll3, [arg_hWin], 10, 225, 100, 18, cID_StatDll3
		mov		[hStatDll3], eax

		invoke	prCreateEdit, ADDR szNoTxt, [arg_hWin], 125, 12, 355, 22, cID_EditExeName
		mov		[hEditExeName], eax
		invoke	prCreateEdit, ADDR szNoTxt, [arg_hWin], 125, 42, 355, 22, cID_EditIcdName
		mov		[hEditIcdName], eax
		invoke	prCreateEdit, ADDR szNoTxt, [arg_hWin], 125, 72, 85, 22, cID_EditVersion
		mov		[hEditVersion], eax
		invoke	prCreateEdit, ADDR szNoTxt, [arg_hWin], 215, 72, 85, 22, cID_EditRelease
		mov		[hEditRelease], eax
		invoke	prCreateEdit, ADDR szNoTxt, [arg_hWin], 125, 102, 85, 22, cID_EditCRC1
		mov		[hEditCrc1], eax
		invoke	prCreateEdit, ADDR szNoTxt, [arg_hWin], 215, 102, 85, 22, cID_EditCRC2
		mov		[hEditCrc2], eax
		invoke	prCreateEdit, ADDR szNoTxt, [arg_hWin], 125, 132, 85, 22, cID_EditTEA1
		mov		[hEditTea1], eax
		invoke	prCreateEdit, ADDR szNoTxt, [arg_hWin], 215, 132, 85, 22, cID_EditTEA2
		mov		[hEditTea2], eax
		invoke	prCreateEdit, ADDR szNoTxt, [arg_hWin], 305, 132, 85, 22, cID_EditTEA3
		mov		[hEditTea3], eax
		invoke	prCreateEdit, ADDR szNoTxt, [arg_hWin], 395, 132, 85, 22, cID_EditTEA4
		mov		[hEditTea4], eax
		invoke	prCreateEdit, ADDR szNoTxt, [arg_hWin], 125, 162, 85, 22, cID_EditDll1_1
		mov		[hEditDll1_1], eax
		invoke	prCreateEdit, ADDR szNoTxt, [arg_hWin], 215, 162, 265, 22, cID_EditDll1_2
		mov		[hEditDll1_2], eax
		invoke	prCreateEdit, ADDR szNoTxt, [arg_hWin], 125, 192, 85, 22, cID_EditDll2_1
		mov		[hEditDll2_1], eax
		invoke	prCreateEdit, ADDR szNoTxt, [arg_hWin], 215, 192, 265, 22, cID_EditDll2_2
		mov		[hEditDll2_2], eax
		invoke	prCreateEdit, ADDR szNoTxt, [arg_hWin], 125, 222, 85, 22, cID_EditDll3_1
		mov		[hEditDll3_1], eax
		invoke	prCreateEdit, ADDR szNoTxt, [arg_hWin], 215, 222, 265, 22, cID_EditDll3_2
		mov		[hEditDll3_2], eax



		invoke	SetTimer, [arg_hWin], cID_Timer, 100, 0
		mov		[dwTimerID], eax

;-----------

	.elseif	[arg_uMsg] == WM_CLOSE

		cmp		[dwThreadStatus], 0		; Thread waiting ?
		jne		@@Ciao0
		mov		[dwThreadStatus], -2	; no new start possible
		invoke	CloseAll

;-----------

	.elseif	[arg_uMsg] == WM_DESTROY

		invoke	PostQuitMessage, 0
		invoke	KillTimer, [arg_hWin], [dwTimerID]
		jmp		@@Ciao0

	.endif

;-----------

	invoke	DefWindowProc, [arg_hWin], [arg_uMsg], [arg_wParam], [arg_lParam]

@@Ciao:
	ret

@@Ciao0:
	sub		eax, eax
	ret

WndProc		ENDP


;-----------------------------------------------------------------------------

	include	inc\Gui\GetWinMiddle.inc
	include	inc\Gui\StaticText.inc
	include	inc\Gui\Button.inc
;	include	inc\Gui\CheckButton.inc
;	include	inc\Gui\GroupBox.inc
	include	inc\Gui\Edit.inc
	include	inc\Thread.inc


;-----------------------------------------------------------------------------
END		Main
