;*****************************************************************************
;*
;*	Get Safedisc Version (InitClose)
;*	Copyright 2000  dec0de12
;*	use MASM (tab4)
;*
;*****************************************************************************

	prCloseHandle	PROTO
	prFreeMem		PROTO

Init	PROC

	invoke	CloseAll

	mov		eax, 2dh
	mov		dword ptr [szIcdName], eax
	mov		dword ptr [szExeName], eax
	sub		eax, eax
	mov		[dwFlags], eax
	mov		[dwImportRVA], eax
	mov		[dwImportFOA], eax
	mov		[dwImportSecParam], eax
	mov		[dwImportSectionRVA], eax
	mov		[dwImportSectionFOA], eax
	mov		[dwImportSectionSize], eax
	mov		[dwRelocRVA], eax
	mov		[dwRelocFOA], eax
	mov		[dwDllKeyNum], eax
	mov		[dwNumFoundKeys], eax
	dec		eax
	mov		[dwRelocTerminator], eax
	mov		[bChangedIcdName], al
	mov		[bChangedExeName], al
	mov		[bChangedVersion], al
	mov		[bChangedRelease], al
	mov		[bChangedCrc], al
	mov		[bChangedTea], al
	mov		[bChangedDll], al
	ret

Init	ENDP


;-----------------------------------------------------------------------------

CloseAll	PROC

	sub		eax, eax
	xchg	eax, [hEXE_File]
	invoke	prCloseHandle

	sub		eax, eax
	xchg	eax, [hICD_File]
	invoke	prCloseHandle

	sub		eax, eax
	xchg	eax, [stExeFileMem.pMem]
	invoke	prFreeMem

	sub		eax, eax
	xchg	eax, [stFileMem.pMem]
	invoke	prFreeMem

	sub		eax, eax
	xchg	eax, [stMarkTabMem.pMem]
	invoke	prFreeMem

	sub		eax, eax
	xchg	eax, [pKeyTabMem]
	invoke	prFreeMem
	ret

CloseAll	ENDP


;-----------------------------------------------------------------------------

prCloseHandle	PROC

	test	eax, eax
	je		@@NoHandle
	invoke	CloseHandle, eax
@@NoHandle:
	ret

prCloseHandle	ENDP

;-----------------------------------------------------------------------------

prFreeMem		PROC

	test	eax, eax
	je		@@NoMemPtr
	invoke	VirtualFree, eax, 0, MEM_RELEASE
@@NoMemPtr:
	ret

prFreeMem		ENDP

;-----------------------------------------------------------------------------
