;*****************************************************************************
;*
;*	Safedisc Analyser (Thread_Load)
;*	Copyright 2000  dec0de12
;*	use MASM (tab4)
;*
;*****************************************************************************


	Init							PROTO
	CloseAll						PROTO
	prTransString					PROTO :DWORD,:DWORD,:DWORD
	ReadSafeMem						PROTO
	WriteSafeMem					PROTO
	WriteSafeMemW					PROTO
	WriteSafeMemB					PROTO
	prOpenFiles						PROTO
	prGetVersion					PROTO
	prGetRawKey						PROTO
	prGetProofCRC					PROTO
	prCalcCodeCRC					PROTO
	prCalcR2Key						PROTO
	prCalcR4Key						PROTO
	prShowErrors					PROTO

;-----------------------------------------------------------------------------


Thread_Load		PROC

	invoke	Init
	invoke	prOpenFiles
	invoke	prGetVersion
	invoke	prGetRawKey
	invoke	prGetProofCRC
	invoke	prCalcCodeCRC
	invoke	prCalcR2Key
	invoke	prCalcR4Key
	invoke	prShowErrors
	mov		[dwThreadStatus], -1			; Thread finished
	ret

Thread_Load		ENDP

;-----------------------------------------------------------------------------


	include	InitClose.inc
	include	standard\PE_Format.inc
	include	standard\StringOps.inc
	include	standard\SafeMemOps.inc
	include	OpenFiles\Open.inc
	include	GetVersion.inc
	include	GetRawKey.inc
	include	CalcCRC.inc
	include	CalcR2\CalcR2.inc
	include	CalcR4Key.inc
	include	ShowErrors.inc

;-----------------------------------------------------------------------------
