;*****************************************************************************
;*
;*	Safedisc Analyser
;*	Copyright 2000  dec0de12
;*	use MASM (tab4)
;*
;*****************************************************************************


CalcR2_CalcTEAKeyMask	PROC

	pushad
	mov		eax, [stDlls.pOrgThunk]
	add		eax, 4							; first dw = 0
	mov		[ebp][stcSafeMem.dwOffset], eax
	mov		[pStSafeMem], ebp
	invoke	ReadSafeMem
	mov		[dwTEA_Key], eax				; Key Base

	mov		eax, [dwImportSectionRVA]
	mov		edx, eax
	add		edx, [dwImportSectionSize]

	mov		esi, 80000000h					; Mask
@@Lp:
	mov		ebx, eax
	and		ebx, esi
	mov		ecx, edx
	and		ecx, esi
	cmp		ebx, ecx
	jne		@@Diff
	cmp		esi, -2
	je		@@Done
	stc
	rcr		esi, 1							; Mask
	jmp		@@Lp

@@Diff:
	shl		esi, 1
@@Done:
	inc		esi								; bit 0 is correct (must point to even RVA)
	mov		[dwTEA_KeyMask], esi
	xor		eax, [dwTEA_Key]				; a crypted Dll-Proc Ptr is stored here
	and		eax, esi
	mov		[dwTEA_Key], eax
	popad
	ret

CalcR2_CalcTEAKeyMask	ENDP


;-----------------------------------------------------------------------------
