;*****************************************************************************
;*
;*	Safedisc Analyser
;*	Copyright 2000  dec0de12
;*	use MASM (tab4)
;*
;*****************************************************************************

CalcR2_InitMarkTab	PROC

	pushad
	mov		eax, [dwImportSectionSize]
	and		eax, 7ffffffh
	shr		eax, 1
	mov		[stMarkTabMem.dwSize], eax
	test	eax, eax
	je		@@Error_AllocMem
	add		eax, 7
	invoke	VirtualAlloc, 0, eax, MEM_COMMIT, PAGE_READWRITE
	test	eax, eax
	jne		@@NoErr_AllocMem
@@Error_AllocMem:
	or		[dwFlags], cFlag_ErrAllocMem
	popad
	ret

@@NoErr_AllocMem:
	mov		[stMarkTabMem.pMem], eax
	mov		edi, eax
	sub		eax, eax
	mov		[stMarkTabMem.dwBase], eax
	mov		[stMarkTabMem.dwOffset], eax
	mov		ecx, [stMarkTabMem.dwSize]
	mov		edx, ecx
	mov		esi, edi
	add		ecx, 3
	shr		ecx, 2
	not		eax
	rep		stosd
	not		eax
	mov		[esi][edx], eax
	mov		[esi][edx][-2], eax

	popad
	ret

CalcR2_InitMarkTab	ENDP


;-----------------------------------------------------------------------------
