;*****************************************************************************
;*
;*	Safedisc Analyser
;*	Copyright 2000  dec0de12
;*	use MASM (tab4)
;*
;*****************************************************************************


CalcR2_ScanForKeys	PROC

	mov		[dwFreeVar], ebp
	pushad
	mov		eax, [dwTEA_KeyMask]
	not		eax
	add		eax, 2
	mov		edx, eax
	and		eax, 1ffffffh
	cmp		eax, edx
	jne		@@BadMask
	shl		eax, 1
	invoke	VirtualAlloc, 0, eax, MEM_COMMIT, PAGE_READWRITE
	test	eax, eax
	jne		@@NoErr_AllocMem
@@BadMask:
	or		[dwFlags], cFlag_ErrAllocMem
	popad
	ret

@@NoErr_AllocMem:
	mov		[pKeyTabMem], eax
	mov		ebp, eax

	mov		esi, [dwTEA_Key]			; esi = Start
	mov		edi, [dwTEA_KeyMask]
	not		edi
	or		edi, esi					; edi = Stop
	jmp		@@StartLp

@@MainLp:
	lea		ebx, stDlls
	mov		ecx, [dwDllKeyNum]
@@Lop:
	mov		eax, [dwFreeVar]
	m2m		[eax][stcSafeMem.dwOffset], [ebx][stcDllKey.pOrgThunk]

@@Lp:
	mov		eax, [dwFreeVar]
	add		[eax][stcSafeMem.dwOffset], 4
	mov		[pStSafeMem], eax
	invoke	ReadSafeMem
	test	eax, eax
	je		@@NextDll
	xor		eax, esi					; decrypt
	sub		eax, [dwImportSectionRVA]
	shr		eax, 1
	mov		[stMarkTabMem.dwOffset], eax
	mov		[pStSafeMem], offset stMarkTabMem
	invoke	ReadSafeMem
	test	al, al						; <>0 -> possible encrypted Asciis
	je		@@NextKey
	jmp		@@Lp

@@NextDll:
	add		ebx, stDllSize
	loop	@@Lop
	mov		[ebp], esi					; Key found
	add		ebp, 4
@@NextKey:
	add		esi, 2
@@StartLp:
	cmp		esi, edi
	jne		@@MainLp
	sub		ebp, [pKeyTabMem]
	shr		ebp, 2
	mov		[dwNumFoundKeys], ebp
@@NoKey:
	popad
	ret

CalcR2_ScanForKeys	ENDP


;-----------------------------------------------------------------------------
