;*****************************************************************************
;*
;*	Safedisc Analyser
;*	Copyright 2000  dec0de12
;*	use MASM (tab4)
;*
;*****************************************************************************


CalcR2_SearchDllKeys	PROC

	lea		edi, szDll1
	lea		ebx, stDlls
	mov		edx, [dwDllKeyNum]

@@MainLp:
	m2m		[ebp][stcSafeMem.dwOffset], [ebx][stcDllKey.pName]
	invoke	CalcR2_TransString
	invoke	prTransString, offset szTextBuffer, edi, 40h
	add		edi, 40h
	pushm	ebx, edx, edi
	invoke	LoadLibrary, offset szTextBuffer
	popm	edi, edx, ebx
	test	eax, eax
	je		@@Error

	mov		[hDllHandle], eax

	mov		esi, [pKeyTabMem]
	mov		ecx, [dwNumLeftAsciis]

@@Lp:
	lodsd
	mov		[ebp][stcSafeMem.dwOffset], eax
	invoke	CalcR2_DecryptString

	pushad
	invoke	GetProcAddress, [hDllHandle], offset szTextBuffer
	test	eax, eax
	popad
	jne		@@KeyFound
	loop	@@Lp
	jmp		@@NoKey

@@KeyFound:
	mov		eax, [esi][-4]
	add		eax, [dwImportSectionRVA]
	xor		eax, [dwTEA_Key]
	mov		[ebx][stcDllKey.dwKey], eax
	add		ebx, stDllSize
	pushm	ebx, edx
	invoke	FreeLibrary, [hDllHandle]
	popm	edx, ebx
	dec		edx
	jne		@@MainLp
	ret


@@NoKey:
	invoke	FreeLibrary, [hDllHandle]

@@Error:
	mov		[dwDllKeyNum], 0
	ret

CalcR2_SearchDllKeys	ENDP

;-----------------------------------------------------------------------------
