;*****************************************************************************
;*
;*	Safedisc Analyser
;*	Copyright 2000  dec0de12
;*	use MASM (tab4)
;*
;*****************************************************************************


CalcR2_TransString	PROC			; uses [pStSafeMem], [ebp][stcSafeMem.dwOffset]

	pushm	eax, edi
	lea		edi, szTextBuffer
	mov		[pStSafeMem], ebp
@@Lp:
	invoke	ReadSafeMem
	stosd
	test	al, al
	je		@@Done
	test	ah, ah
	je		@@Done
	bswap	eax
	test	al, al
	je		@@Done
	test	ah, ah
	je		@@Done
	add		[ebp][stcSafeMem.dwOffset], 4
	jmp		@@Lp

@@Done:
	popm	edi, eax
	ret

CalcR2_TransString	ENDP


;-----------------------------------------------------------------------------

CalcR2_DecryptString	PROC		; uses [pStSafeMem], [ebp][stcSafeMem.dwOffset]

	pushm	eax, ecx, edi
	lea		edi, szTextBuffer
	mov		[pStSafeMem], ebp
	invoke	ReadSafeMem
	mov		cl, al
	and		ecx, 3fh					; Num Chars
	shr		eax, 8
	xor		al, 3dh						; first Char
	stosb
	inc		[ebp][stcSafeMem.dwOffset]
@@Lp:
	inc		[ebp][stcSafeMem.dwOffset]
	invoke	ReadSafeMem
	xor		al, ah
	stosb
	je		@@Done
	loop	@@Lp

@@Done:
	popm	edi, ecx, eax
	ret

CalcR2_DecryptString	ENDP


;-----------------------------------------------------------------------------
