;*****************************************************************************
;*
;*	Safedisc Analyser
;*	Copyright 2000  dec0de12
;*	use MASM (tab4)
;*
;*****************************************************************************

cDECRPE_dw1				= "RCED"					; "DECR"
cDECRPE_dw2				= 4550h						; "PE",0,0
cDECRPE_ICD				= "DCI"						; "ICD",0

;-----------------------------------------------------------------------------

prGetRawKey		PROC

	pushad
	test	[dwFlags], cFlag_ExeLoaded
	je		@@NoExe
	cmp		[dwVersion], 20000000h
	jae		@@NoExe									; No V2

	mov		esi, [stExeFileMem.pMem]
	mov		edi, [stExeFileMem.dwSize]
	add		edi, esi
	mov		edx, cDECRPE_dw1
	mov		ecx, cDECRPE_dw2
	mov		ebx, cDECRPE_ICD
@@Lp1:
	cmp		esi, edi
	jae		@@NoDecrpe
	lodsd
	cmp		eax, edx
	jne		@@Lp1
	cmp		[esi], ecx
	jne		@@Lp1
	add		esi, 104h
	jmp		@@Lp2

@@NoDecrpe:
	mov		esi, [stExeFileMem.pMem]
@@Lp2:
	cmp		esi, edi
	jae		@@NoExe
	lodsd
	cmp		eax, ebx
	jne		@@Lp2
	sub		esi, 104h
	cmp		esi, [stExeFileMem.pMem]
	jbe		@@NoExe

	lea		edi, dwRaw_Key
	movsd
	movsd
	movsd
	movsd
	or		[dwFlags], cFlag_Raw_KeysFound

@@NoExe:
	popad
	ret


prGetRawKey		ENDP

;-----------------------------------------------------------------------------
