;*****************************************************************************
;*
;*	Get Safedisc Version (FindImports)
;*	Copyright 2000  dec0de12
;*	use MASM (tab4)
;*
;*****************************************************************************

prFindImports		PROC

	pushad
	lea		esi, tSectionParam
	mov		ecx, [dwSectionNum]

@@Lp:
	mov		eax, [esi][stcSectionParam.dwFlags]
	test	eax, cFlag_SecImport
	jne		@@Found

	add		esi, sizeof stcSectionParam
	loop	@@Lp
	sub		eax, eax
	jmp		@@NoImport

@@Found:
	mov		[dwImportSecParam], esi
	mov		eax, [esi][stcSectionParam.dwRVA]
	mov		[dwImportSectionRVA], eax
	mov		eax, [esi][stcSectionParam.dwFOA]
	mov		[dwImportSectionFOA], eax
	mov		eax, [esi][stcSectionParam.dwSize]
	mov		[dwImportSectionSize], eax

	mov		eax, [dwImportRVA]
	sub		eax, [esi][stcSectionParam.dwRVA]
	add		eax, [esi][stcSectionParam.dwFOA]

@@NoImport:
	mov		[dwImportFOA], eax						; 0 = No Imports
	popad
	ret

prFindImports		ENDP


;-----------------------------------------------------------------------------
