;*****************************************************************************
;*
;*	Safedisc Analyser
;*	Copyright 2000  dec0de12
;*	use MASM (tab4)
;*
;*****************************************************************************

prOpenFile	PROC	arg_pMask		:DWORD,
					arg_pHandle		:DWORD,
					arg_pSize		:DWORD,
					arg_ppMem		:DWORD

	pushad
	mov		[szOFN_FileName], 0
	mov		eax, [arg_pMask]
	mov		[stOpenFile.lpstrFilter], eax
	mov		eax, [hWnd]
	mov		[stOpenFile.hWndOwner], eax
	invoke	GetOpenFileNameA, offset stOpenFile
	test	eax, eax
	je		@@NoFile

	invoke	CreateFileA, offset szOFN_FileName, GENERIC_READ, FILE_SHARE_READ, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0
	cmp		eax, -1
	jne		@@Open_Ok
	or		[dwFlags], cFlag_ErrOpenFile
	jmp		@@NoFile

@@Open_Ok:
	mov		edi, [arg_pHandle]
	stosd
	invoke	GetFileSize, eax, 0
	and		eax, 7ffffffh
	mov		edi, [arg_pSize]
	stosd
	add		eax, 3ffh
	and		eax, 0fffff00h
	invoke	VirtualAlloc, 0, eax, MEM_COMMIT, PAGE_READWRITE
	test	eax, eax
	jne		@@Mem_Ok

	or		[dwFlags], cFlag_ErrAllocMem
	jmp		@@NoFileClose

@@Mem_Ok:
	mov		edi, [arg_ppMem]
	stosd
	mov		esi, [arg_pSize]
	mov		ecx, [esi]
	mov		esi, [arg_pHandle]
	mov		edx, [esi]
	invoke	ReadFile, edx, eax, ecx, offset dwFreeVar, 0
	test	eax, eax
	je		@@ReadError

	sub		al, al
	jmp		@@Ciao

;-----------------------------------------------------------------------------

@@ReadError:
	or		[dwFlags], cFlag_ErrReadFile

@@NoFileClose:
	mov		esi, [arg_pHandle]
	mov		edx, [esi]
	invoke	CloseHandle, edx

@@NoFile:
	mov		al, 1
@@Ciao:
	test	al, al
	popad
	ret

prOpenFile	ENDP

;-----------------------------------------------------------------------------
